package adm

import (
	"context"
	"gd_vehicle/apis"
	"gd_vehicle/consts"
	"gd_vehicle/errors"
	dutils "gd_vehicle/utils"
	"strconv"

	"github.com/tidwall/gjson"
)

func A01(ctx context.Context, plateNo, plateType string, lReqs *[]apis.ThirdpartLogWrite, providerMap map[string]apis.MerchantProviderLimitInfo, rangeNo int) (vin string, err error) {
	// ADM-A01
	if CheckProviderApiIsAvaliable(dutils.ADMA01, providerMap, rangeNo) == nil {
		str, err := (&Adm{
			Ctx: ctx,
			Params: map[string]string{
				"plate_no":   plateNo,
				"plate_type": plateType,
			},
			Code:     consts.A01,
			LReqs:    lReqs,
			Provider: providerMap[dutils.ADMA01+strconv.Itoa(rangeNo)],
		}).Request()

		if err != nil {
			return vin, err
		}

		dataObj := gjson.Parse(str).Get("list").Array()
		for _, v := range dataObj {
			vin = v.Get("vin").String()
			break
		}
	} else {
		return vin, errors.ProviderUnavailable
	}

	return
}
