package adm

import (
	"context"
	"gd_vehicle/apis"
	"gd_vehicle/consts"
	"gd_vehicle/errors"
	"strconv"

	dutils "gd_vehicle/utils"

	jsoniter "github.com/json-iterator/go"
)

func U01(ctx context.Context, str string, LReqs *[]apis.ThirdpartLogWrite, providerMap map[string]apis.MerchantProviderLimitInfo, rangeNo int) (string, error) {
	if CheckProviderApiIsAvaliable(dutils.ADMU01, providerMap, rangeNo) == nil {
		params := make(map[string]string)
		_ = jsoniter.UnmarshalFromString(str, &params)
		str, err := (&Adm{
			Ctx:      ctx,
			Params:   params,
			Code:     consts.U01,
			LReqs:    LReqs,
			Provider: providerMap[dutils.ADMU01+strconv.Itoa(rangeNo)],
		}).Request()

		if err == nil {
			return str, nil
		} else {
			return "", err
		}
	} else {
		return "", errors.ProviderUnavailable
	}
}
