package adm

import (
	"context"
	"gd_vehicle/apis"
	"gd_vehicle/consts"
	"gd_vehicle/errors"
	dutils "gd_vehicle/utils"
	"strconv"

	"github.com/tidwall/gjson"
)

func V01(ctx context.Context, plateNo, plateType, owner string, lReqs *[]apis.ThirdpartLogWrite, providerMap map[string]apis.MerchantProviderLimitInfo, rangeNo int) (isMatch string, err error) {
	if CheckProviderApiIsAvaliable(dutils.ADMV01, providerMap, rangeNo) == nil {
		str, err := (&Adm{
			Ctx: ctx,
			Params: map[string]string{
				"plate_no":   plateNo,
				"plate_type": plateType,
				"owner":      owner,
			},
			Code:     consts.V01,
			LReqs:    lReqs,
			Provider: providerMap[dutils.ADMV01+strconv.Itoa(rangeNo)],
		}).Request()

		if err != nil {
			return isMatch, err
		}
		isMatch = gjson.Get(str, "is_match").String()
	} else {
		return isMatch, errors.ProviderUnavailable
	}

	return isMatch, err
}
