// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.

package vehicle

import (
	"context"
	"gd_vehicle/apis"
	"gd_vehicle/consts"
	"gd_vehicle/errors"
	"gd_vehicle/impl/thirdparty_impl/adm"
	"gd_vehicle/utils"
)

// vin查车辆信息
func A002(ctx context.Context, req *apis.CommonReq, reply *apis.CommonReply) error {
	rData := req.Data.(map[string]interface{})
	vin := rData["vin"].(string)
	MerchantProviderLimitInfoList, err := utils.GetProviderInfo(req.MerchantApiInfo.MerchantChildApiId, req.BaseApiId)
	if err != nil {
		return errors.ServiceError
	}

	providerMap, _ := utils.GenProviderInfoMapNew(MerchantProviderLimitInfoList)
	respData := make(map[string]string)
	// TODO 定义返回字段

	err = adm.A04(ctx, "", "", vin, respData, &reply.LReq, providerMap, consts.RANGEONE)
	if err == nil {
		reply.Data = respData
		return nil
	} else {
		return errors.NoRecord
	}
}
