// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.

package vehicle

import (
	"context"
	"gd_vehicle/errors"
	"strings"

	"gd_vehicle/apis"
)

func Query(ctx context.Context, req *apis.CommonReq, reply *apis.CommonReply) error {
	interfaces := map[string]func(ctx context.Context, req *apis.CommonReq, reply *apis.CommonReply) error{
		"1001":     A001,
		"1002":     A002,
		"2001":     V001,
		"2002":     V002,
		"TEST_API": TestApi,
	}

	if v, ok := interfaces[strings.ToUpper(req.Code)]; ok {
		err := v(ctx, req, reply)
		if err == nil {
			// TODO 调用u01格式化

			return nil
		}
		return err
	}

	return errors.NoRecord
}
